﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using DecisioLinqEntity.ObjectModel;

namespace WindowsFormsInfraTeam13_2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            UltraGrid0.DataSource = MakeDataModel(420, 8, 12);
            ultraGrid1.DataSource = MakeDataModel(420, 8, 12);
            ultraGrid2.DataSource = MakeDataModel(420, 8, 12);
            ultraGrid3.DataSource = MakeDataModel(420, 8, 12);
        }
               

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            //Auto Fit
            UltraGrid0.DisplayLayout.Bands[0].PerformAutoResizeColumns(false, PerformAutoSizeType.VisibleRows);
            ultraGrid1.DisplayLayout.Bands[0].PerformAutoResizeColumns(false, PerformAutoSizeType.VisibleRows);
            ultraGrid2.DisplayLayout.Bands[0].PerformAutoResizeColumns(false, PerformAutoSizeType.VisibleRows);
            ultraGrid3.DisplayLayout.Bands[0].PerformAutoResizeColumns(false, PerformAutoSizeType.VisibleRows);
        }

        /// <summary>
        /// We make sample data ( Ugly code for data test, forgive me Infragistics team)
        /// </summary>
        /// <param name="NumberRows">Number of DestinationModelBand</param>
        /// <param name="NumberChild">Number of CheminModelBand</param>
        /// <param name="NumberPath">Number of CheminModelBand</param>
        /// <returns></returns>
        public List<DESTINATION_MODEL> MakeDataModel(short NumberRows, short NumberChild, short NumberPath)
        {
            List<DESTINATION_MODEL> DataModel = new List<DESTINATION_MODEL>(NumberRows);
            //Band 0
            for (short row = 0; row < NumberRows; row++)
            {

                DESTINATION_MODEL temp = new DESTINATION_MODEL();

                temp.CAT_TEMP = "SU";
                temp.SEQ_DESTINATION = row;
                temp.COD_ENSEIGNE = "01234";
                temp.LIB_ENSEIGNE = "MyLIB";
                temp.COD_ETAB = "255323";
                temp.CODE_LOC = "255542";
                temp.CODE_TYP_DEST = "1";
                temp.LIB_ETAB = "MyLIBETAB";
                temp.LIB_LOC = "MyLIBLOC";
                temp.IS_AUTO_ADDED = 1;
                temp.LIB_REG_ADM = "MyLIBREG";
                temp.LIB_SOUS_TYPE = "HM";
                temp.LIB_TYP_DEST = "MyLIBETAB";
                temp.NUM_SOUS_TYP = 1;
                temp.PDEP = "FR" + NumberRows;            
                temp.SEQ_VERSION_TARIF = 0;
                temp.Pourc_Direct = 0;
                temp.PAL_FIN_GROUPAGE = 10;
                temp.PAL_COMPLET = 5;
                temp.MARGE_COMPLET = 3;
                temp.COUT_CAMION_LH = 10;

                //Hiden Band
                for (short path = 0; path < NumberPath; path++)
                {

                    CHEMIN_MODEL chemVer = new CHEMIN_MODEL();


                    chemVer.INDICE_GASOIL_TRAC_INIT = 0.58m;
                    chemVer.INDICE_GASOIL_TRANSIT_INIT = 0.58m;
                    chemVer.INDICE_GASOIL_DEGR_INIT = 0.58m;
                    chemVer.COD_AGE_TRANSIT = "80001A";
                    chemVer.COD_DEGR = "25523";
                    chemVer.LIB_AGE_TRANSIT = "MyTransit";
                    chemVer.TYP_LIV = "LIV";
                    chemVer.POURCENT_AGE_DEST_INIT = 9m;
                    chemVer.NB_HR_SUPP_LH_INIT = 0.3m;
                    chemVer.NB_PAL_LH_INIT = 27;
                    chemVer.NB_TRAC_PAL_CALC = 27;
                    chemVer.NB_HR_SUPP_LH = 27;
                    chemVer.NB_PAL_LH = 27;
                    chemVer.NB_POS = 10;
                    chemVer.NB_POS_TOT = 100;
                    chemVer.NBR_TRAC_PAL_INIT = 10;
                    chemVer.NB_TRAC_PAL_CALC = 20;
                    chemVer.SEQ_CHEMIN = path;
                    chemVer.SEQ_DESTINATION = row;
                    chemVer.LIB_DEGR = "MyLibDegr";
                    chemVer.IS_AUTO_ADDED = 1;
                    chemVer.POURCENT_AGE_DEST_CALC = 10;
                    chemVer.NB_HR_SUPP_LH = 0.3m;
                    chemVer.NB_PAL_LH = 27;
                    chemVer.NB_TRAC_PAL_CALC = 27;
                    chemVer.COUT_DEGR_PAL1_CALC = 1;
                    chemVer.COUT_DEGR_PAL2_CALC = 1;
                    chemVer.COUT_DEGR_PAL3_CALC = 1;
                    chemVer.COUT_DEGR_PAL4_CALC = 1;
                    chemVer.COUT_DEGR_PAL5_CALC = 1;
                    chemVer.COUT_DEGR_PAL6_CALC = 1;
                    chemVer.COUT_DEGR_PAL7_CALC = 1;
                    chemVer.COUT_DEGR_PAL8_CALC = 1;
                    chemVer.COUT_DEGR_PAL9_CALC = 1;
                    chemVer.COUT_DEGR_PAL10_CALC = 1;

                    chemVer.COUT_DEGR_PO25_CALC = 1;
                    chemVer.COUT_DEGR_PO75_CALC = 1;
                    chemVer.COUT_DEGR_PO125_CALC = 1;
                    chemVer.COUT_DEGR_PO175_CALC = 1;
                    chemVer.COUT_DEGR_PO225_CALC = 1;
                    chemVer.COUT_DEGR_PO275_CALC = 1;
                    chemVer.COUT_DEGR_PO400_CALC = 1;
                    chemVer.COUT_DEGR_PO650_CALC = 1;
                    chemVer.COUT_DEGR_PO1150_CALC = 1;
                    chemVer.COUT_DEGR_PO2250_CALC = 1;
                    chemVer.COUT_DEGR_PO4000_CALC = 1;
                    chemVer.COUT_DEGR_PO6000_CALC = 1;
                    chemVer.COUT_DEGR_PO8000_CALC = 1;

                    chemVer.COUT_DEGR_PO25_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO75_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO125_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO175_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO225_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO275_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO400_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO650_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO1150_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO2250_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO4000_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO6000_INFR_CALC = 1;
                    chemVer.COUT_DEGR_PO8000_INFR_CALC = 1;

                    //card Band
                    for (short cardNumber = 0; cardNumber < NumberChild; cardNumber++)
                    {
                        COUT_TRANCHE_MODEL temp3 = new COUT_TRANCHE_MODEL();

                        temp3.MARGE_AVEC_FAFE = 5;
                        temp3.MARGE_DEST_TRANCHE = 5;
                        temp3.IS_VAL_VARIABLE = 0;
                        temp3.TARIF_TRANCHE = NumberRows / NumberChild;
                        temp3.SEQ_MOD_GRILLE_VRS = 3;
                        temp3.SEQ_DESTINATION = row;
                        temp3.NORDRE_TRANCHE = NumberChild;
                        temp3.NUM_TRANCHE = NumberChild;
                        temp3.COUT_DEGR_TRANCHE = 23;
                        temp3.COUT_PAQ = 3;
                        temp3.COUT_RAMASSE = 4;
                        temp3.COUT_STRUCTURE = 34;
                        temp3.COUT_STRUCTURE_FONCT = 3;
                        temp3.COUT_STRUCTURE_OPER = 3;
                        temp3.COUT_STRUCTURE_SIEGE = 4;
                        temp3.COUT_TRAC_MOY = 44;
                        temp3.COUT_TRANSIT_MOY = 4;
                        temp3.ECART_TRANCHE = 2;

                        temp.COUT_TRANCHE.Add(temp3);

                    }
                    temp.CHEMIN_MODEL.Add(chemVer);
                }
                DataModel.Add(temp);
            }


            return DataModel;
        }
    }
}
